//
//  UIPanGestureRecognizer+VelocityDirection.h
//  Created by Devin Ross on 4/23/15.
//
/*
 
 curry || https://github.com/devinross/curry-fire
 
 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the "Software"), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:
 
 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
 
 */

@import UIKit;

/** Additionality functionality for `UIPanGestureRecognizer` to determine the velocity. */
@interface UIPanGestureRecognizer (VelocityDirection)

/** The velocity direction is trending upward. */
- (BOOL) velocityIsUp;

/** The velocity is trending more downward. */
- (BOOL) velocityIsDown;

/** The velocity is trending more to the left. */
- (BOOL) velocityIsLeft;

/** The velocity is trending more to the right. */
- (BOOL) velocityIsRight;

/** The velocity is trending more up-and-down. */
- (BOOL) velocityIsVertical;

/** The velocity is trending more left-to-right. */
- (BOOL) velocityIsHorizontal;


@end
